/*
 * generated by Xtext 2.32.0
 */
package no.ntnu.tdt4250.sm.textual.serializer;

import com.google.inject.Inject;
import java.util.Set;
import no.ntnu.tdt4250.sm.SmPackage;
import no.ntnu.tdt4250.sm.State;
import no.ntnu.tdt4250.sm.StateMachine;
import no.ntnu.tdt4250.sm.Transition;
import no.ntnu.tdt4250.sm.textual.services.StateMachineDSLGrammarAccess;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.xtext.Action;
import org.eclipse.xtext.Parameter;
import org.eclipse.xtext.ParserRule;
import org.eclipse.xtext.serializer.ISerializationContext;
import org.eclipse.xtext.serializer.acceptor.SequenceFeeder;
import org.eclipse.xtext.serializer.sequencer.AbstractDelegatingSemanticSequencer;
import org.eclipse.xtext.serializer.sequencer.ITransientValueService.ValueTransient;

@SuppressWarnings("all")
public class StateMachineDSLSemanticSequencer extends AbstractDelegatingSemanticSequencer {

	@Inject
	private StateMachineDSLGrammarAccess grammarAccess;
	
	@Override
	public void sequence(ISerializationContext context, EObject semanticObject) {
		EPackage epackage = semanticObject.eClass().getEPackage();
		ParserRule rule = context.getParserRule();
		Action action = context.getAssignedAction();
		Set<Parameter> parameters = context.getEnabledBooleanParameters();
		if (epackage == SmPackage.eINSTANCE)
			switch (semanticObject.eClass().getClassifierID()) {
			case SmPackage.STATE:
				sequence_State(context, (State) semanticObject); 
				return; 
			case SmPackage.STATE_MACHINE:
				sequence_SM(context, (StateMachine) semanticObject); 
				return; 
			case SmPackage.TRANSITION:
				sequence_Transition(context, (Transition) semanticObject); 
				return; 
			}
		if (errorAcceptor != null)
			errorAcceptor.accept(diagnosticProvider.createInvalidContextOrTypeDiagnostic(semanticObject, context));
	}
	
	/**
	 * <pre>
	 * Contexts:
	 *     SM returns StateMachine
	 *
	 * Constraint:
	 *     (
	 *         name=EString 
	 *         state+=State 
	 *         state+=State* 
	 *         transition+=Transition 
	 *         transition+=Transition* 
	 *         initial=[State|EString] 
	 *         final+=[State|EString] 
	 *         final+=[State|EString]*
	 *     )
	 * </pre>
	 */
	protected void sequence_SM(ISerializationContext context, StateMachine semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * <pre>
	 * Contexts:
	 *     State returns State
	 *
	 * Constraint:
	 *     (name=EString (children+=State children+=State*)?)
	 * </pre>
	 */
	protected void sequence_State(ISerializationContext context, State semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * <pre>
	 * Contexts:
	 *     Transition returns Transition
	 *
	 * Constraint:
	 *     (name=EString source=[State|EString] target=[State|EString])
	 * </pre>
	 */
	protected void sequence_Transition(ISerializationContext context, Transition semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, SmPackage.Literals.TRANSITION__NAME) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, SmPackage.Literals.TRANSITION__NAME));
			if (transientValues.isValueTransient(semanticObject, SmPackage.Literals.TRANSITION__SOURCE) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, SmPackage.Literals.TRANSITION__SOURCE));
			if (transientValues.isValueTransient(semanticObject, SmPackage.Literals.TRANSITION__TARGET) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, SmPackage.Literals.TRANSITION__TARGET));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getTransitionAccess().getNameEStringParserRuleCall_0_0(), semanticObject.getName());
		feeder.accept(grammarAccess.getTransitionAccess().getSourceStateEStringParserRuleCall_2_0_1(), semanticObject.eGet(SmPackage.Literals.TRANSITION__SOURCE, false));
		feeder.accept(grammarAccess.getTransitionAccess().getTargetStateEStringParserRuleCall_4_0_1(), semanticObject.eGet(SmPackage.Literals.TRANSITION__TARGET, false));
		feeder.finish();
	}
	
	
}
